//
--  All Base Ability Sprites and Code Needed For Luigi Go Here!
-- (Finally Figured It Out...)
//

-- Base/Special Swap (Somewhat like M&L I Guess... Not Direct Inspiration)

// Swap Code

addHook("PlayerThink", function(p)
    if (p.mo) and (p.mo.skin == "tposeluigi")
        if (p.cmd.buttons & BT_CUSTOM1) and (p.pressc1 == true) then //If pressing C1
            if not (p.pflags & PF_JUMPDOWN)
                p.pressc1 = false //We probably want this to run only once per C1 press
                p.pflags = p.pflags + PF_JUMPDOWN		
                if (p.charability == CA_TWINSPIN) then 
                    p.charability = CA_FLOAT
	                S_StartSound(expl, sfx_acpt)	    					
                else
                    p.charability = CA_TWINSPIN
					S_StartSound(expl, sfx_decl)
                end
            end
        end
        if not (p.cmd.buttons & BT_CUSTOM1) then //If NOT pressing C1
            p.pressc1 = true //You can now press it again
        end
    end
end)

// Upward Gust Code

freeslot (
"S_PLAY_GFAL", "SPR2_GFAL"
)

states[S_PLAY_GFAL] = {
        sprite = SPR_PLAY,
        frame = SPR2_GFAL,
        tics = 1,
		nextstate = S_PLAY_GFAL
}


 addHook("PlayerThink", function(player)
    if player.mo.skin ~= "tposeluigi" then
        return
    end
if (player.mo.state == S_PLAY_TWINSPIN) and (player.charability == CA_TWINSPIN) and not player.powers[pw_super] then
    player.mo.momz = 20*FRACUNIT	
	player.mo.state = S_PLAY_GFAL
    local expl = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_EXPL)
	 expl.spriteyscale = FRACUNIT/3
     expl.spritexscale = FRACUNIT/3
	 S_StartSound(expl, sfx_expl)	
  end
 end)

 addHook("PlayerThink", function(player)
    if player.mo.skin ~= "tposeluigi" then
        return
    end
if (player.mo.state == S_PLAY_SPINDASH) and player.dashmode == 3*TICRATE and not player.powers[pw_super] then
    player.mo.momz = 40*FRACUNIT	
	player.mo.state = S_PLAY_GFAL
    local expl = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_EXPL)
	 expl.spriteyscale = FRACUNIT/2
     expl.spritexscale = FRACUNIT/2
	 S_StartSound(expl, sfx_expl)	
  end
 end)



//player.mo.eflags = $|MFE_FORCESUPER

// End of Swap Code



-- Coyote Time Code (Graced To Me By King 2401, THIS IS THE MEAT OF ALOT OF GOOD. IT [while unintentionally at first] ALLOWS FOR ALOT OF FUN)

-- TLD:R (Special Out Of Springs, Float Kills, Jump Out Of Hurt Frames, Ect. Fun)

// Coyote Time Code

addHook("PlayerThink", function(p)
	if p.mo and p.mo.skin == "tposeluigi" then
		if not(P_IsObjectOnGround(p.mo)) and not (P_PlayerInPain(p)) and not p.powers[pw_carry] then
            p.pflags = $ | PF_JUMPED
		end
	end
end)

// End Of Coyote Time Code

-- Poltergust (Inspired From The Luigi's Mansion Series. It's Luigi, gotta have it!)

//Sucking Ability

 addHook("PlayerThink", function(player)
if player.mo and player.mo.valid and player.mo.skin == "tposeluigi" and not (player.charability == CA_FLOAT) then

  if (P_IsObjectOnGround(player.mo)) 
  and (player.mo.state == S_PLAY_SPINDASH) 
	 P_Telekinesis(player, -64*FRACUNIT, 500*FRACUNIT)
  end
end
end)

//Burnout Activation

addHook("ThinkFrame", do
    for player in players.iterate
        if (player.mo.valid) and (player.mo.skin == "tposeluigi")
            if player.dashmode == 3*TICRATE and player.mo.state == S_PLAY_SPINDASH
                P_NukeEnemies(player.mo, player.mo, 500*FRACUNIT)
                P_FlashPal(player, PAL_WHITE, 2)
            end
        end
    end
end)
	
//Crispys

//addHook("PlayerThink", function(player)
//    local r = player.mo.radius / FRACUNIT
//    local explosion = P_SpawnMobj(
//        player.mo.x + (P_RandomRange(r, -r) * FRACUNIT),
//        player.mo.y + (P_RandomRange(r, -r) * FRACUNIT),
//        player.mo.z + (P_RandomKey(player.mo.height / FRACUNIT) * FRACUNIT),
//        MT_SONIC3KBOSSEXPLODE)
//        S_StartSound(explosion, sfx_s3kb4)
//    end
//end)	
		
//End Of Poltergust Code

-- Duck

//addHook("PlayerThink", function(player)
//    if player.mo.skin ~= "tposeluigi" then
//        return
//    end
//
//   if (player.cmd.buttons & BT_USE) and P_IsObjectOnGround(player.mo) and player.speed == 0 then
//        player.height = 30*FRACUNIT
//        player.mo.state = S_PLAY_GLIDE_LANDING
//        player.pflags = $1|PF_FULLSTASIS
//    else
//        player.height = 48*FRACUNIT
//    end
//end)
