//
--  All Special Sprites and Code Needed For Luigi Go Here!
-- (Finally Figured It Out...)
//

-- Shell (Inspired From SMDS's Blue Shell! One of the BEST Powerups... In my personal opinion of course! :])

freeslot (
 "SPR2_SHEL", "S_PLAY_SHEL"
)
 
states[S_PLAY_SHEL] = {
		sprite = SPR_PLAY,
		frame = FF_ANIMATE|SPR2_SHEL,
		tics = 1,
		nextstate = S_PLAY_SHEL
}

// Shell Code

 addHook("PlayerThink", function(player)
    if player.mo.skin ~= "tposeluigi" then
        return
    end
	
    if (player.charability == CA_FLOAT) and not player.powers[pw_super] and not (P_PlayerInPain(player)) and (player.mo.state == S_PLAY_SPINDASH) or (player.charability == CA_FLOAT) and not player.powers[pw_super] and (player.mo.state == S_PLAY_ROLL) and not (P_PlayerInPain(player))
    player.mo.state = S_PLAY_SHEL
  end
 end)

addHook("MobjMoveBlocked", function(mo, thing, line)
    if not mo.skin == "tposeluigi" then return end
    if (mo.state == S_PLAY_SHEL)
	
	if line and line.valid
		if FixedHypot(mo.momx, mo.momy) > 5*FRACUNIT
			if abs(line.dx) > 0
				local myang = R_PointToAngle2(0, 0, mo.momx, mo.momy)
				local lineang = R_PointToAngle2(line.v1.x, line.v1.y, line.v2.x, line.v2.y)
				P_InstaThrust(mo, myang + 2*(lineang - myang), FixedHypot(30*FRACUNIT, 30*FRACUNIT))
				S_StartSound(mobj, sfx_bump)
			else
				mo.momx = $*-1
			end
		end
	end
end
end)

 addHook("PlayerThink", function(player)
    if player.mo.skin ~= "tposeluigi" then
        return
    end
if (player.cmd.buttons & BT_USE) and not P_IsObjectOnGround(player.mo) and (player.charability == CA_FLOAT) and not player.powers[pw_super] and player.mo.state == S_PLAY_JUMP then
    player.mo.state = S_PLAY_SHEL
  end
 end)

// End of Shell Code



-- Nook (Inspired From Tanooki Suit in SM3DLand, Simple But Still Fun!) 

freeslot (
"S_PLAY_NSTK", "SPR2_NSTK"
)

states[S_PLAY_NSTK] = {
        sprite = SPR_PLAY,
        frame = SPR2_NSTK,
        tics = 1,
		nextstate = S_PLAY_NSTK
}


freeslot (
"S_PLAY_NSTO", "SPR2_NSTO"
)

states[S_PLAY_NSTO] = {
        sprite = SPR_PLAY,
        frame = SPR2_NSTO,
        tics = 1,
		nextstate = S_PLAY_NSTO
}

// Nook Code

addHook("PlayerThink", function(player)
    if player.mo.skin ~= "tposeluigi" then
        return
    end
	
    if (player.charability == CA_FLOAT) and not player.powers[pw_super] and not(P_IsObjectOnGround(player.mo)) and not (P_PlayerInPain(player)) and (player.mo.state == S_PLAY_FLOAT_RUN) or (player.mo.state == S_PLAY_FLOAT) and (player.charability == CA_FLOAT) and not player.powers[pw_super]
    player.mo.state = S_PLAY_NSTK
 end
end)

 addHook("PlayerThink", function(player)
    if player.mo.skin ~= "tposeluigi" then
        return
    end
if (player.cmd.buttons & BT_SPIN) and player.mo.state == S_PLAY_FALL and not player.powers[pw_super] and (player.charability == CA_FLOAT) then
    player.mo.momz = -28*FRACUNIT
    player.mo.state = S_PLAY_NSTO
 end
end)

 addHook("PlayerThink", function(player)
    if player.mo.skin ~= "tposeluigi" then
        return
    end
if  player.mo.state == S_PLAY_NSTO and (P_IsObjectOnGround(player.mo)) then
    player.mo.momx = 0
	player.mo.momy = 0
	player.mo.momz = 0
    player.mo.state = S_PLAY_GLIDE_LANDING	
 end
end)


// End of Nook Code


-- Retro Luigi (Inspired From Super Paper Mario! So Iconic, just like the game!)

// Retro Luigi Code
 
 addHook("PlayerThink", function(player)
     if player.mo.skin ~= "tposeluigi" then
        return
    end

 if player.powers[pw_super] and not (player.charability == CA_FLOAT)
 player.height = 10*FRACUNIT
 player.radius = 10*FRACUNIT
 player.mo.spriteyscale = FRACUNIT/3
 player.mo.spritexscale = FRACUNIT/3
 else
 player.height = 60*FRACUNIT
 player.radius = 32*FRACUNIT
 player.mo.spriteyscale = FRACUNIT
 player.mo.spritexscale = FRACUNIT
end
end)

 addHook("PlayerThink", function(player)
     if player.mo.skin ~= "tposeluigi" then
        return
    end

 if player.powers[pw_super] and (player.charability == CA_FLOAT)
 player.mo.scale = 5*FRACUNIT
 else
 player.mo.scale = 1*FRACUNIT
end
end)
 

// End Of Retro Luigi Code


