//Spawns Dust Particles (Kirb)

addHook("PlayerThink", function(player) 
if player.mo and player.mo.valid and player.mo.skin == "tposeluigi" then

  if (P_IsObjectOnGround(player.mo)) 
  and (player.mo.state == S_PLAY_DASH or player.mo.state == S_PLAY_SPRING)
	P_SpawnSkidDust(player, 13*FRACUNIT, sfx_none)
  end
  if (player.mo.state == S_PLAY_SPRING or player.mo.state == S_PLAY_JUMP)
	P_SpawnSkidDust(player, 13*FRACUNIT, sfx_none)
  end
   if (player.mo.state == S_PLAY_SPINDASH)
	P_SpawnSkidDust(player, 20*FRACUNIT, sfx_none)
  end 
  if player.dashmode > 3*TICRATE or player.mo.state == S_PLAY_NIGHTS_DRILL
    P_SpawnGhostMobj(player.mo)
  end
end
end)


//Custom Music

addHook("MusicChange", function(oldname, newname)
	if consoleplayer
		local character = skins[consoleplayer.skin].name
		if character == "tposeluigi" //skin to use custom themes
			if newname == "_super" //intercept and override jingles
				return "SUPS"
			end
		end
	end
end)


//Animation Tick Speed

addHook("ThinkFrame", do
	for player in players.iterate
		if (player.mo and player.mo.skin == "tposeluigi")
			if (player.mo.state == S_PLAY_STND)
				if (player.mo.anim_duration > 3)
					player.mo.anim_duration = 3
				end
			elseif (player.mo.state == S_PLAY_WAIT)
				if (player.mo.anim_duration > 4)
					player.mo.anim_duration = 4
				end
			elseif (player.mo.state == S_PLAY_WALK)
				if (player.mo.tics >= 2)
					player.mo.tics = player.mo.tics/2
				end
			elseif (player.mo.state == S_PLAY_RUN)
				if (player.mo.tics > 1)
					player.mo.tics = 1
				end
			elseif (player.mo.state == S_PLAY_FALL)
				if (player.mo.tics > 2)
					player.mo.tics = 2
				end
			elseif (player.mo.state == S_PLAY_SPRING)
				if (player.mo.tics > 1)
					player.mo.tics = 1
				end
			else
				continue
			end
		end
	end
end)

// Death Animation

addHook("MobjDeath", function(player)

    if not (player and player.valid) return end
    if not (player.flags & MT_PLAYER) return end
    player.state = S_PLAY_GASP
    --spawn the ring
	 player.delObj = true
    local expl = P_SpawnMobj(player.x, player.y, player.z, MT_EXPL)
	 expl.spriteyscale = FRACUNIT/3
     expl.spritexscale = FRACUNIT/3
	 S_StartSound(expl, sfx_expl)
	local coin = P_SpawnMobj(player.x, player.y, player.z+41*FRACUNIT, MT_YOSHICOIN)
    coin.momz = 10*FRACUNIT
	coin.momx = 1*FRACUNIT
	coin.spriteyscale = FRACUNIT/3
    coin.spritexscale = FRACUNIT/3
	
end)

freeslot (
 "SPR2_IMAB", "S_PLAY_IMAB"
)
 
states[S_PLAY_IMAB] = {
		sprite = SPR_PLAY,
		frame = FF_ANIMATE|SPR2_IMAB,
		tics = 4,
		nextstate = S_PLAY_GASP
}

addHook("PlayerThink", function(player)
    if player.mo and player.mo.skin == "tposeluigi" and (player.mo.state == S_PLAY_GFAL) and leveltime % 30 == 0 then
        for i = 0, 8
            local fa = (i*(ANGLE_180/4))
            local dust = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_SPINDUST)
            dust.momx = FixedMul(sin(fa),10*FRACUNIT)
            dust.momy = FixedMul(cos(fa),10*FRACUNIT)
        end
    end
end)

